
#include "fdf.h"

static void	swap_x_y(t_pnt *p1, t_pnt *p2)
{
	int temp;

	temp = p1->x;
	p1->x = p1->y;
	p1->y = temp;
	temp = p2->x;
	p2->x = p2->y;
	p2->y = temp;
}

static void	swap_points(t_pnt *p1, t_pnt *p2)
{
	t_pnt temp;

	temp = *p1;
	*p1 = *p2;
	*p2 = temp;

}

static void	draw_line(t_pnt *p1, t_pnt *p2, t_mlx *m, t_swap *s)
{
	int dx = abs(p2->x - p1->x);
	int dy = abs(p2->y - p1->y);
	int derr = 2 * dy - dx;
	while (p1->x < p2->x)
	{
		if (s->swap_coord)
			mlx_pixel_put(m->mlx, m->win, p1->y, p1->x, 0xFFFFFF);
		else
			mlx_pixel_put(m->mlx, m->win, p1->x, p1->y, 0xFFFFFF);
		if (derr > 0)
		{
			p1->y += s->swap_x;
			derr -= dx;
		}
		(p1->x)++;
		derr += dy;
	}
}

void	line(t_pnt p1, t_pnt p2, t_mlx *m)
{
	int dx;
	int dy;
	t_swap swap;

	dx = abs(p2.x - p1.x);
	dy = abs(p2.y - p1.y);
	swap.swap_coord = 0;
	swap.swap_x = 1;
	if (dy > dx)
	{
		swap_x_y(&p1, &p2);
		swap.swap_coord= 1;
	}
	if (p1.x > p2.x)
		swap_points(&p1, &p2);
	if (p1.y > p2.y)
		swap.swap_x = -1;
	draw_line(&p1, &p2, m, &swap);
}

