// C/C++ File
// AUTHOR:   foton
// FILE:     main.c
// ROLE:     to rule them all
// CREATED:  2017-01-30 21:51:28
// MODIFIED: 2017-02-13 20:30:48

#include "fdf.h"
#include <stdio.h>
#include <time.h>




void	test_line(t_mlx mlx)
{
	t_pnt	p1;
	t_pnt	p2;
	int	temp;

	p1.color = 0xC100E5;
	p2.color = 0xC100E5;
	for (p2.y = 0; p2.y <= 500; p2.y += 4)
	{
		p1.x = 0;
		p1.y = 0;
		p2.x = 500;
		line(p1, p2, &mlx);
	}
	for (p2.x = 500; p2.x >= 0; p2.x -= 4)
	{
		p1.x = 0;
		p1.y = 0;
		p2.y = 500;
		temp = p2.x;
		line(p1, p2, &mlx);
		p2.x = temp;
	}
	p1.color = 0x1EBF00;
	p2.color = 0x1EBF00;
	for (p2.y = 0; p2.y <= 500; p2.y += 4)
	{
		p1.x = 500;
		p1.y = 0;
		p2.x = 0;
		temp = p2.y;
		line(p1, p2, &mlx);
		p2.y = temp;
	}
	for (p2.x = 0; p2.x <= 500; p2.x += 4)
	{
		p1.x = 500;
		p1.y = 0;
		p2.y = 500;
		temp = p2.x;
		line(p1, p2, &mlx);
		p2.x = temp;
	}
}

void	circle(t_mlx m)
{
	t_pnt	p1;
	t_pnt	p2;
	double angle;


	for (int i = 0; i < 360; i += 4)
	{
		p1.x = 250;
		p1.y = 250;
		angle = i * M_PI / 180;
		p2.x = p1.x + 200 * sin(angle);
		p2.y = p1.y + 200 * cos(angle);
		line(p1, p2, &m);
	}
}

int     key_hook(int keycode, void *m)
{
    printf("%d\n", keycode);
	  if (keycode == 65307)
		  quit(m);
//    if (keycode == 123)
//        left(mlx);
//    if (keycode == 126)
//        up(mlx);
//    if (keycode == 125)
//        down(mlx);
    return (0);
}

int		main(int argc, char **argv)
{
	t_mlx	m;
	t_map	*map;

	if (argc != 2)
		return (0);
	m.mlx = mlx_init();
	m.win = mlx_new_window(m.mlx, 500, 500, "fdf");
	map = map_init(argv[1]);
	pnt_init(map);
	//circle(m);
	render(map, &m, 500, 500);
    mlx_key_hook(m.win, key_hook, &m);
	mlx_loop(m.mlx);
	return (0);
}
